var AssetsManager;
(function(){
    AssetsManager = cc.Scene.extend({
        _failCount : 0,
        _am:null,
        _progress:null,
        _percent:0,
        _percentByFile:0,

        run:function(){
            var me = this;

            if (!cc.sys.isNative) {
                this.loadGame();
                return;
            }

            cc.loader.resPath = "res";
            var node = ccs.CSLoader.createNode('preload.csb');
            this.ui = node;
            this.addChild(this.ui);
            ccui.helper.doLayout(this.ui);

            var text = ccui.helper.seekWidgetByName(this.ui,'text'),
                jdt = ccui.helper.seekWidgetByName(this.ui,'jdt');
            text.setString('正在检查资源版本...');

            var storagePath  = me.storagePath = (jsb.fileUtils ? jsb.fileUtils.getWritablePath() : "./");

            //清空临时文件
            var projectTemp  = storagePath+'project.manifest.temp.tmp';
            if(jsb.fileUtils.isFileExist(projectTemp)){
                jsb.fileUtils.removeFile(projectTemp);
            }

            var versionTemp  = storagePath+'version.manifest.temp.tmp';
            if(jsb.fileUtils.isFileExist(versionTemp)){
                jsb.fileUtils.removeFile(versionTemp);
            }

            this._am = new jsb.AssetsManager("res/_project.manifest", storagePath);
            this._am.retain();

            if (!this._am.getLocalManifest().isLoaded()){
                cc.log("Fail to update assets, step skipped.");
                this.loadGame();
            }else{
                var listener = new jsb.EventListenerAssetsManager(this._am, function(event) {
                    cc.log('event.getEventCode='+event.getEventCode());

                    switch (event.getEventCode()){
                        //event.getAssetId() event.getMessage()
                        case jsb.EventAssetsManager.NEW_VERSION_FOUND:
                            //有新版本
                            me.needUpdate && me.needUpdate();
                            break;
                        case jsb.EventAssetsManager.ERROR_NO_LOCAL_MANIFEST://本地文件有问题
                        case jsb.EventAssetsManager.ERROR_DOWNLOAD_MANIFEST://下载外网manifest错误
                        case jsb.EventAssetsManager.ERROR_PARSE_MANIFEST://解析外网manifest错误
                        case jsb.EventAssetsManager.ALREADY_UP_TO_DATE://已经是最新版
                        case jsb.EventAssetsManager.UPDATE_FINISHED://更新完成
                        case jsb.EventAssetsManager.ERROR_UPDATING://更新错误
                        case jsb.EventAssetsManager.ERROR_DECOMPRESS://解压错误
                            me.loadGame();
                            break;
                        case jsb.EventAssetsManager.UPDATE_PROGRESSION:
                            me._percent = event.getPercent();
                            me._percentByFile = event.getPercentByFile();
                            if(me._percent*1>0){
                                jdt.setPercent(parseInt(me._percent));
                                text.setString('正在更新资源('+ parseInt(me._percent) +'%)');
                            }
                            break;
                        case jsb.EventAssetsManager.UPDATE_FAILED:
                            me._failCount++;
                            if (me._failCount < 5){
                                me._am.downloadFailedAssets();//重试
                            }else{
                                me._failCount=0;
                                me.loadGame();
                            }
                            break;
                        default:
                            break;
                    }
                });
                cc.eventManager.addListener(listener, 1);
                this._am.update();
                cc.director.runScene(this);
            }
        },
        needUpdate : function(){
            var me = this;
            return;
            if(!me._hasTips){
                me._hasTips = true;
                me.alert();
            }
        },
        alert : function(msg){
            var me = this;
            if(!cc.sys.isObjectValid(me.alertNode)){
                var _csb = 'tishi.csb';
                me.alertNode = ccs.CSLoader.createNode(_csb);
                me.alertAction = ccs.CSLoader.createTimeline(_csb);
                me.alertNode.runAction(me.alertAction);
                me.addChild(me.alertNode);
                me.alertNode.zIndex = 10;

                ccui.helper.seekWidgetByName(me.alertNode,'bg_list').height = 300;

                var buttonbg = ccui.helper.seekWidgetByName(me.alertNode,'buttonbg')
                //确定按钮
                var _okbtn = new ccui.Button();
                _okbtn.setTouchEnabled(true);
                _okbtn.setName('btn_ok');
                _okbtn.setAnchorPoint(cc.p(0.5,0.5));
                _okbtn.setTitleFontSize(28);
                _okbtn.loadTextureNormal('img/public/btn_green.png',ccui.Widget.PLIST_TEXTURE);
                _okbtn.setTitleText('更 新');
                _okbtn.x = 170;
                _okbtn.y = buttonbg.height/2;
                _okbtn.addTouchEventListener(function(sender,type){
                    if(type==ccui.Widget.TOUCH_ENDED){
                        me._am.update();
                        me.alertAction.play('out',false);
                    }
                },_okbtn);
                buttonbg.addChild(_okbtn);

                //取消按钮
                var _cancelbtn = new ccui.Button();
                _cancelbtn.setTouchEnabled(true);
                _cancelbtn.setName('btn_cancel');
                _cancelbtn.setAnchorPoint(cc.p(0.5,0.5));
                _cancelbtn.setTitleFontSize(28);
                _cancelbtn.loadTextureNormal('img/public/btn_red.png',ccui.Widget.PLIST_TEXTURE);
                _cancelbtn.setTitleText('关 闭');
                _cancelbtn.x = 470;
                _cancelbtn.y = buttonbg.height/2;
                _cancelbtn.addTouchEventListener(function(sender,type){
                    if(type==ccui.Widget.TOUCH_ENDED){
                        cc.loader.loadJs(["src/game.min.js"], function(err){
                            X.callNative(null,null,{
                                act:'exit'
                            });
                        });
                    }
                },_cancelbtn);
                buttonbg.addChild(_cancelbtn);

                ccui.helper.doLayout(me.alertNode);
            }
            me.alertNode.setVisible(true);
            me.alertAction.play('in',false);

            var listview = ccui.helper.seekWidgetByName(me.alertNode,'listview');
            var richText = new ccui.Text();
            richText.fontSize = 20;
            richText.color = cc.color('#000000');
            richText.setString("有新资源需要更新，是否现在下载？");
            listview.pushBackCustomItem(richText);
        },
        loadGame:function(){
            var me = this;
            cc.loader.loadJs(["src/game.min.js"], function(err){
                C.init();
                C.WS = C.D.getWinSize();
                cc.director.runScene(new GameScene());
            });
        },
        onExit:function(){
            this._am.release();
            this._super();
        }
    });
})();